Attribute VB_Name = "mSMARTCall"
Option Explicit

Public Type ATTR_DATA
    AttrID As Byte
    AttrValue As Byte
    RawValue As Currency
    ThresholdValue As Byte
    WorstValue As Byte
    StatusFlags As STATUS_FLAGS
End Type

Public Type DRIVE_INFO
'IDNTIFY structure data
    GenConfig                   As Integer 'Word 0
    Cilinders                   As Integer 'Word 1
    Reserved                    As Integer 'Word 2
    Heads                       As Integer 'Word 3
    BytesPerTrack               As Integer 'Word 4
    BytesPerSector              As Integer 'Word 5
    SectorsPerTrack             As Integer 'Word 6
    VendorUnique(2)             As Integer 'Word 7-9
    SerialNumber                As String * 20 'Word 10-19
    BufferType                  As Integer 'Word 20
    BufferSize                  As Integer 'Word 21
    ECCSize                     As Integer 'Word 22
    FirmWare                    As String * 8 'Word 23-26
    ModelNumber                 As String * 40 'Word 27-46
    MoreVendorUnique            As Integer 'Word 47
    DoubleWordIO                As Integer 'Word 48
    Capabilities                As Integer 'Word 49
    Reserved1                   As Integer 'Word 50
    PIOTiming                   As Integer 'Word 51
    DMATiming                   As Integer 'Word 51
    BS                          As Integer 'Word 53
    NumCurrentCyls              As Integer 'Word 54
    NumCurrentHeads             As Integer 'Word 55
    NumCurrentSectorsPerTrack   As Integer 'Word 56
    CurrentSectorCapacity(1)    As Integer 'Word 57-58
    MultSectorStuff             As Integer 'Word 59
    TotalAddressableSectors(1)  As Integer 'Word 60-61
    SingleWordDMA               As Integer 'Word 62
    MultiWordDMA                As Integer 'Word 63
    AdvancedPIOMode             As Integer 'Word 64
    MinDMATime                  As Integer 'Word 65
    RecommendDMATime            As Integer 'Word 66
    MinPIOTime                  As Integer 'Word 67
    MinPIOTimeIORDY             As Integer 'Word 68
    Reserved2(5)                As Integer 'Word 69-74
    QueueDepth                  As Integer 'Word 75
    Reserved3(3)                As Integer 'Word 76-79
    MajorVersion                As Integer 'word 80
    MinorVersion                As Integer 'word 81
    CommandSetSupported(2)      As Integer 'Word 82-84
    CommandSetEnabled(2)        As Integer 'Word 85-87
    UltraDMA                    As Integer 'Word 88
    SecurityEraseTime           As Integer 'Word 89
    EnhSecurityEraseTime        As Integer 'Word 90
    AdvPowerManagement          As Integer 'Word 91
    MasterPassword              As Integer 'Word 92
    HardwareReset               As Integer 'Word 93
    AcousticData                As Integer 'Word 94
    StreamMinRequestSize        As Integer 'Word 95
    StreamTransferTimeDMA       As Integer 'Word 96
    StreamAccessLatency         As Integer 'Word 97
    StreamPerfGranularity(1)    As Integer 'Word 98-99
    MaxUserLBA48(3)             As Integer 'Word 100-103
    StreamTransferTimePIO       As Integer 'Word 104
    Reserved4                   As Integer 'Word 105
    PhysSectorSize              As Integer 'Word 106
    InterSeekDelay              As Integer 'Word 107
    UniqueID(3)                 As Integer 'Word 108-111
    Reserved5(4)                As Integer 'Word 112-116
    WordsPerLogicalSector(1)    As Integer 'Word 117-118
    Reserved6(7)                As Integer 'Word 119-126
    RemovableMediaNotify        As Integer 'Word 127
    SecurityStatus              As Integer 'Word 128
    VendorSpecific(30)          As Integer 'Word 129-159
    CFAPowerMode                As Integer 'Word 160
    Reserved7(14)               As Integer 'Word 161-175
    CurrentMediaSN(29)          As Integer 'Word 176-205
    Reserved8(48)               As Integer 'Word 206-254
    IntegrityWord               As Integer 'Word 255
'Additional data
    TotalSize                   As Double
    bDriveType                  As Integer
    NumAttributes               As Byte
    Attributes()                As ATTR_DATA
    signature                   As Long
    PartitionCount              As Long
    PartInfo()                  As PARTITION_INFORMATION
    LogicalDrivesCount          As Long
    LogicalDrives()             As VOLUME_INFORMATION
End Type

Public Enum IDE_DRIVE_NUMBER
    PRIMARY_MASTER
    PRIMARY_SLAVE
    SECONDARY_MASTER
    SECONDARY_SLAVE
End Enum

Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, lpOutBuffer As Any, ByVal nOutBufferSize As Long, lpBytesReturned As Long, ByVal lpOverlapped As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const OPEN_EXISTING = 3
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const CREATE_NEW = 1

Public Const INVALID_HANDLE_VALUE = -1
Dim di As DRIVE_INFO
Public colAttr As colAttributes

'***************************************************************************
' Open SMART to allow DeviceIoControl communications. Return SMART handle
'***************************************************************************
Private Function OpenSmart(drv_num As IDE_DRIVE_NUMBER) As Long
   If IsWindowsNT Then
      OpenSmart = CreateFile("\\.\PhysicalDrive" & CStr(drv_num), GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
   Else
      OpenSmart = CreateFile("\\.\SMARTVSD", 0, 0, ByVal 0&, CREATE_NEW, 0, 0)
   End If
End Function

'****************************************************************************
' CheckSMARTEnable - Check if SMART enable
' FUNCTION: Send a SMART_ENABLE_SMART_OPERATIONS command to the drive
' bDriveNum = 0-3
'***************************************************************************}
Private Function CheckSMARTEnable(ByVal hDrive As Long, DriveNum As IDE_DRIVE_NUMBER) As Boolean
   'Set up data structures for Enable SMART Command.
   Dim SCIP As SENDCMDINPARAMS
   Dim SCOP As SENDCMDOUTPARAMS
   Dim lpcbBytesReturned As Long
   With SCIP
       .cBufferSize = 0
       With .irDriveRegs
            .bFeaturesReg = SMART_ENABLE_SMART_OPERATIONS
            .bSectorCountReg = 1
            .bSectorNumberReg = 1
            .bCylLowReg = SMART_CYL_LOW
            .bCylHighReg = SMART_CYL_HI
   'Compute the drive number.
            .bDriveHeadReg = &HA0 Or (DriveNum And 1) * 16
            .bCommandReg = IDE_EXECUTE_SMART_FUNCTION
        End With
        .bDriveNumber = DriveNum
   End With
   CheckSMARTEnable = DeviceIoControl(hDrive, DFP_SEND_DRIVE_COMMAND, SCIP, Len(SCIP) - 4, SCOP, Len(SCOP) - 4, lpcbBytesReturned, ByVal 0&)
End Function

'****************************************************************************
' DoIdentify
' Function: Send an IDENTIFY command to the drive
' DriveNum = 0-3
' IDCmd = IDE_ID_FUNCTION or IDE_ATAPI_ID
'*****************************************************************************
Private Function IdentifyDrive(ByVal hDrive As Long, ByVal IDCmd As Byte, ByVal DriveNum As IDE_DRIVE_NUMBER) As Boolean
    Dim SCIP As SENDCMDINPARAMS
    Dim IDSEC As IDSECTOR
    Dim bArrOut(OUTPUT_DATA_SIZE - 1) As Byte
    Dim lpcbBytesReturned As Long
    Dim i As Long
    Dim curSize As Currency
'   Set up data structures for IDENTIFY command.
    With SCIP
        .cBufferSize = IDENTIFY_BUFFER_SIZE
        .bDriveNumber = CByte(DriveNum)
        With .irDriveRegs
             .bFeaturesReg = 0
             .bSectorCountReg = 1
             .bSectorNumberReg = 1
             .bCylLowReg = 0
             .bCylHighReg = 0
' Compute the drive number.
            .bDriveHeadReg = &HA0 + DriveNum
            If Not IsWindowsNT Then .bDriveHeadReg = .bDriveHeadReg Or (DriveNum And 1) * 16
' The command can either be IDE identify or ATAPI identify.
             .bCommandReg = CByte(IDCmd)
        End With
    End With
    If DeviceIoControl(hDrive, DFP_RECEIVE_DRIVE_DATA, SCIP, Len(SCIP) - 4, bArrOut(0), OUTPUT_DATA_SIZE, lpcbBytesReturned, ByVal 0&) Then
       IdentifyDrive = True
       CopyMemory IDSEC, bArrOut(16), Len(IDSEC)
       CopyMemory di, IDSEC, Len(IDSEC)
       di.SerialNumber = Trim(SwapStringBytes(StrConv(IDSEC.sSerialNumber, vbUnicode)))
       di.FirmWare = Trim(SwapStringBytes(StrConv(IDSEC.sFirmwareRev, vbUnicode)))
       di.ModelNumber = Trim(SwapStringBytes(StrConv(IDSEC.sModelNumber, vbUnicode)))
       di.MoreVendorUnique = IDSEC.wMoreVendorUnique
'calculate size based on 28 bit or 48 bit addressing
       If di.MaxUserLBA48(0) Then 'LBA 48-bit mode
          CopyMemory curSize, di.MaxUserLBA48(0), 8
          di.TotalSize = curSize * 5120000
       ElseIf di.TotalAddressableSectors(0) Then 'LBA mode
          CopyMemory curSize, di.TotalAddressableSectors(0), 4
          di.TotalSize = curSize * 5120000
       ElseIf di.CurrentSectorCapacity(0) Then 'Extended CHS mode
          CopyMemory curSize, di.CurrentSectorCapacity(0), 4
          di.TotalSize = curSize * 5120000
       Else 'Old CHS mode
          di.TotalSize = CDbl(di.BytesPerSector) * di.Cilinders * di.Heads * di.SectorsPerTrack
       End If
    End If
End Function

'****************************************************************************
' ReadAttributesCmd
' FUNCTION: Send a SMART_READ_ATTRIBUTE_VALUES command to the drive
' bDriveNum = 0-3
'***************************************************************************}
Private Function ReadAttributesCmd(ByVal hDrive As Long, DriveNum As IDE_DRIVE_NUMBER) As Boolean
   Dim cbBytesReturned As Long
   Dim SCIP As SENDCMDINPARAMS
   Dim drv_attr As DRIVEATTRIBUTE
   Dim bArrOut(OUTPUT_DATA_SIZE - 1) As Byte
   Dim i As Long
   With SCIP
 ' Set up data structures for Read Attributes SMART Command.
       .cBufferSize = READ_ATTRIBUTE_BUFFER_SIZE
       .bDriveNumber = DriveNum
       With .irDriveRegs
            .bFeaturesReg = SMART_READ_ATTRIBUTE_VALUES
            .bSectorCountReg = 1
            .bSectorNumberReg = 1
            .bCylLowReg = SMART_CYL_LOW
            .bCylHighReg = SMART_CYL_HI
'  Compute the drive number.
            .bDriveHeadReg = &HA0 + DriveNum
            If Not IsWindowsNT Then .bDriveHeadReg = .bDriveHeadReg Or (DriveNum And 1) * 16
            .bCommandReg = IDE_EXECUTE_SMART_FUNCTION
       End With
  End With
  ReadAttributesCmd = DeviceIoControl(hDrive, DFP_RECEIVE_DRIVE_DATA, SCIP, Len(SCIP) - 4, bArrOut(0), OUTPUT_DATA_SIZE, cbBytesReturned, ByVal 0&)
  On Error Resume Next
  Dim j As Long
  For i = 0 To NUM_ATTRIBUTE_STRUCTS - 1
      If bArrOut(18 + i * 12) > 0 Then
         di.Attributes(di.NumAttributes).AttrID = bArrOut(18 + i * 12)
         CopyMemory di.Attributes(di.NumAttributes).StatusFlags, bArrOut(19 + i * 12), 2
         di.Attributes(di.NumAttributes).AttrValue = bArrOut(21 + i * 12)
         di.Attributes(di.NumAttributes).WorstValue = bArrOut(22 + i * 12)
         CopyMemory di.Attributes(di.NumAttributes).RawValue, bArrOut(23 + i * 12), 6
         di.NumAttributes = di.NumAttributes + 1
         ReDim Preserve di.Attributes(di.NumAttributes)
      End If
  Next i
End Function

'****************************************************************************
' ReadThresholdsCmd
' FUNCTION: Send a SMART_READ_ATTRIBUTE_THRESHOLDS command to the drive
' bDriveNum = 0-3
'***************************************************************************}
Private Function ReadThresholdsCmd(ByVal hDrive As Long, DriveNum As IDE_DRIVE_NUMBER) As Boolean
   Dim cbBytesReturned As Long
   Dim SCIP As SENDCMDINPARAMS
   Dim IDSEC As IDSECTOR
   Dim bArrOut(OUTPUT_DATA_SIZE - 1) As Byte
   Dim thr_attr As ATTRTHRESHOLD
   Dim i As Long, j As Long
   With SCIP
 ' Set up data structures for Read Attributes SMART Command.
       .cBufferSize = READ_THRESHOLD_BUFFER_SIZE
       .bDriveNumber = DriveNum
       With .irDriveRegs
            .bFeaturesReg = SMART_READ_ATTRIBUTE_THRESHOLDS
            .bSectorCountReg = 1
            .bSectorNumberReg = 1
            .bCylLowReg = SMART_CYL_LOW
            .bCylHighReg = SMART_CYL_HI
'  Compute the drive number.
            .bDriveHeadReg = &HA0 + DriveNum
            If Not IsWindowsNT Then .bDriveHeadReg = .bDriveHeadReg Or (DriveNum And 1) * 16
            .bCommandReg = IDE_EXECUTE_SMART_FUNCTION
       End With
  End With
  ReadThresholdsCmd = DeviceIoControl(hDrive, DFP_RECEIVE_DRIVE_DATA, SCIP, Len(SCIP) - 4, bArrOut(0), OUTPUT_DATA_SIZE, cbBytesReturned, ByVal 0&)
  For i = 0 To NUM_ATTRIBUTE_STRUCTS - 1
      CopyMemory thr_attr, bArrOut(18 + i * Len(thr_attr)), Len(thr_attr)
      If thr_attr.bAttrID > 0 Then
         For j = 0 To UBound(di.Attributes)
             If thr_attr.bAttrID = di.Attributes(j).AttrID Then
                di.Attributes(j).ThresholdValue = thr_attr.bWarrantyThreshold
                Exit For
             End If
         Next j
      End If
  Next i
End Function

Private Function GetSmartVersion(ByVal hDrive As Long, VersionParams As GETVERSIONOUTPARAMS) As Boolean
   Dim cbBytesReturned As Long
   GetSmartVersion = DeviceIoControl(hDrive, DFP_GET_VERSION, ByVal 0&, 0, VersionParams, Len(VersionParams), cbBytesReturned, ByVal 0&)
End Function

Public Function GetDriveInfo(DriveNum As IDE_DRIVE_NUMBER) As DRIVE_INFO
    Dim hDrive As Long
    Dim VerParam As GETVERSIONOUTPARAMS
    Dim cb As Long
    di.bDriveType = 0
    di.NumAttributes = 0
    ReDim di.Attributes(0)
    hDrive = OpenSmart(DriveNum)
    If hDrive = INVALID_HANDLE_VALUE Then Exit Function
    If Not GetSmartVersion(hDrive, VerParam) Then Exit Function
    If Not IsBitSetByte(VerParam.bIDEDeviceMap, DriveNum) Then Exit Function
    di.bDriveType = 1 + Abs(IsBitSetByte(VerParam.bIDEDeviceMap, DriveNum + 4))
    If Not CheckSMARTEnable(hDrive, DriveNum) Then Exit Function
    Call IdentifyDrive(hDrive, IDE_ID_FUNCTION, DriveNum)
    Call ReadAttributesCmd(hDrive, DriveNum)
    Call ReadThresholdsCmd(hDrive, DriveNum)
    Call GetPartitionsInfo(hDrive)
    Call GetVolumesInfo
    GetDriveInfo = di
    CloseHandle hDrive
End Function

Private Function GetPartitionsInfo(ByVal hDrive As Long) As Boolean
   Dim sDLI As DRIVE_LAYOUT_INFORMATION
   Dim i As Integer, nPartitionUsed As Integer
   Dim cbBytesReturned As Long
   
   If DeviceIoControl(hDrive, IOCTL_DISK_GET_DRIVE_LAYOUT, ByVal 0&, 0, sDLI, Len(sDLI), cbBytesReturned, ByVal 0&) Then
      di.signature = sDLI.signature
      For i = 0 To sDLI.PartitionCount - 1
          If sDLI.PartitionEntry(i).PartitionNumber > 0 Then
             ReDim Preserve di.PartInfo(nPartitionUsed)
             di.PartInfo(nPartitionUsed) = sDLI.PartitionEntry(i)
             nPartitionUsed = nPartitionUsed + 1
          End If
       Next i
       di.PartitionCount = nPartitionUsed
   End If
End Function

Private Function GetVolumesInfo() As Boolean
   Dim vi() As VOLUME_INFORMATION
   Dim n As Long
   
   n = GetDriveLogicalVolumes(di.signature, vi)
   di.LogicalDrivesCount = n
   di.LogicalDrives = vi
End Function
